<?php

/* MapCreator - "Interaktive Karten mit Google-Maps"
 * Erzeugt anhand der mit Symbohlbefehl in $acticon bergebenen Parameter das JavaScript fr die Google-Maps-API Schnitstelle
 *
 * @version 1.2
 * @author Matthias Fleischer
 * @copyright 2008 by MFD|WEB http://www.mfdweb.de
 * @lizenz CreativeCommons cc-by-sa 3.0 de (Namensnennung-Weitergabe unter gleichen Bedingungen 3.0 Deutschland) http://creativecommons.org/licenses/by-sa/3.0/de/
 */

defined('CMBASIC') or die();
define('ADDPATH', 'minibot/');

preg_match_all("/{((map),?([-.0-9]*?),?([-.0-9]*?),?(.*?))}/i", $acticon, $kartenfund);

if (isset($kartenfund)) { // Prft ob Kartenbefehl vorhanden
    $MAP_No = 1;
    $GmapTyp = array('G_NORMAL_MAP', 'G_SATELLITE_MAP', 'G_HYBRID_MAP', 'G_PHYSICAL_MAP'); // Kartentypen 0-3
    $Switch = array('on', 'off');
    if (file_exists(ADDPATH . 'MapCreator.ini')) { // Prft ob MapCreator.ini vorhanden
        $inifile = fopen(ADDPATH . 'MapCreator.ini', 'r');
        while (!feof($inifile)) { // Holt Werte aus MapCreator.ini
            $inipart = explode('=', trim(fgets($inifile)));
            $mapset[$inipart[0]] = $inipart[1];
        }
        fclose($inifile);
        if (!empty($mapset['APIkey']) && $APIkey != '0') {
            foreach ($kartenfund[1] as $kartenpara_komp) { // Arbeitet einzelnen die Fundstellen ab
                $kartenpara = explode(',', $kartenpara_komp);
                extract($mapset); // $APIkey, $MAPlat, $MAPlng, $MAPinfo, $MAPzoom, $MAPbreite, $MAPhoehe, $MAPtype, $MAPMapC, $MAPTypeC, $MAPScaleC, $MAPOverview
                $MAP_type = $GmapTyp[$MAPtype];
                $MAP_geo = "$MAPlat,$MAPlng";
                $MAP_poi = array(array($MAPlat, $MAPlng, $MAPinfo));
                if (!empty($kartenpara[1]) && !empty($kartenpara[2])) { // Prft auf alternative Koordinaten usw.
                    if (is_numeric($kartenpara[1])) $MAPlat = $kartenpara[1];
                    if (is_numeric($kartenpara[2])) $MAPlng = $kartenpara[2];
                    if (!empty($kartenpara[3])) $MAPinfo = $kartenpara[3];
                    else $MAPinfo = "";
                    if (ctype_digit($kartenpara[4]) && $kartenpara[4] >= 0 && $kartenpara[4] <= 20) $MAPzoom = $kartenpara[4];
                    if (ctype_digit($kartenpara[5])) $MAPbreite = substr($kartenpara[5], 0, 3);
                    if (ctype_digit($kartenpara[6])) $MAPhoehe = substr($kartenpara[6], 0, 3);
                    if (ctype_digit($kartenpara[7])) $MAP_type = $GmapTyp[$kartenpara[7]];
                    $MAP_geo = "$MAPlat,$MAPlng";
                    $MAP_poi = array(array($MAPlat, $MAPlng, $MAPinfo));
                } else if (!empty($kartenpara[1]) && file_exists("media/$kartenpara[1]")) { // Prft auf csv Koordinatendatei im Ordner media
                    $MAPfile = fopen("media/$kartenpara[1]", 'r');
                    while (!feof($MAPfile)) { // Holt Werte aus Koordinatendatei
                        $MAPpart[] = explode(',', trim(fgets($MAPfile)));
                    }
                    fclose($MAPfile);
                    if (!empty($MAPpart[0][0]) && !empty($MAPpart[0][1])) {
                        if (is_numeric($MAPpart[0][0])) $MAPlat = $MAPpart[0][0];
                        if (is_numeric($MAPpart[0][1])) $MAPlng = $MAPpart[0][1];
                        if (ctype_digit($MAPpart[0][2]) && $MAPpart[0][2] >= 0 && $MAPpart[0][2] <= 20) $MAPzoom = $MAPpart[0][2];
                        if (ctype_digit($MAPpart[0][3])) $MAPbreite = substr($MAPpart[0][3], 0, 3);
                        if (ctype_digit($MAPpart[0][4])) $MAPhoehe = substr($MAPpart[0][4], 0, 3);
                        if (ctype_digit($MAPpart[0][5])) $MAP_type = $GmapTyp[$MAPpart[0][5]];
                        if (!empty($MAPpart[0][6]) && in_array($MAPpart[0][6], $Switch)) $MAPMapC = $MAPpart[0][6];
                        if (!empty($MAPpart[0][7]) && in_array($MAPpart[0][7], $Switch)) $MAPTypeC = $MAPpart[0][7];
                        if (!empty($MAPpart[0][8]) && in_array($MAPpart[0][8], $Switch)) $MAPScaleC = $MAPpart[0][8];
                        if (!empty($MAPpart[0][9]) && in_array($MAPpart[0][9], $Switch)) $MAPOverview = $MAPpart[0][9];
                        $MAP_geo = "$MAPlat,$MAPlng";
                        $MAP_poi = array_slice($MAPpart, 1);
                    }
                    unset($MAPpart);
                }
                if ($MAP_No == 1) { // Ausgabe des APIkey in head bei 1. Karte
                    $head .= "<script src=\"http://maps.google.com/maps?file=api&amp;v=2&amp;key={$APIkey}\" type=\"text/javascript\"></script>\n";
                }
                $kartencode = "\n<div id=\"map_{$MAP_No}\" class=\"map\" style=\"width:{$MAPbreite}px; height:{$MAPhoehe}px; overflow:hidden\"><noscript>
<img alt=\"Karte_{$MAP_No}\" src=\"http://maps.google.com/staticmap?center={$MAP_geo}&zoom={$MAPzoom}&size={$MAPbreite}x{$MAPhoehe}&markers=";
                $POI_No = 1;
                foreach($MAP_poi as $Marker) { // Markierungspunkte setzen
                    $kartencode .= "{$Marker[0]},{$Marker[1]},red{$POI_No}%7C";
                    $POI_No++;
                }
                $kartencode .= "&key={$APIkey}\" />
</noscript></div>
<script type=\"text/javascript\">\n//<![CDATA[
  if (GBrowserIsCompatible()) {
    var map_{$MAP_No} = new GMap2(document.getElementById(\"map_{$MAP_No}\"));
    map_{$MAP_No}.addMapType(G_PHYSICAL_MAP);
    map_{$MAP_No}.setMapType({$MAP_type});\n";
                if ($MAPMapC == "on") {
                    if ($MAPhoehe > 399) $kartencode .= "    map_{$MAP_No}.addControl(new GLargeMapControl());\n";
                    else if ($MAPhoehe > 199) $kartencode .= "    map_{$MAP_No}.addControl(new GSmallMapControl());\n";
                    else $kartencode .= "    map_{$MAP_No}.addControl(new GSmallZoomControl());\n";
                }
                if ($MAPTypeC == "on") {
                    if ($MAPbreite > 349) $kartencode .= "    map_{$MAP_No}.addControl(new GMapTypeControl());\n";
                    else $kartencode .= "    map_{$MAP_No}.addControl(new GMenuMapTypeControl());\n";
                }
                if ($MAPScaleC == "on") {
                    $kartencode .= "    map_{$MAP_No}.addControl(new GScaleControl());\n";
                }
                if ($MAPOverview == "on") {
                    if ($MAPbreite > 299 && $MAPhoehe > 199) $kartencode .= "    map_{$MAP_No}.addControl(new GOverviewMapControl());\n";
                }
                $kartencode .= "    map_{$MAP_No}.setCenter(new GLatLng({$MAP_geo}), {$MAPzoom});\n";
                $POI_No = 1;
                foreach($MAP_poi as $Marker) { // Markierungspunkte setzen
                    $Marker[2] = str_replace('"',"'",$Marker[2]);
                    $kartencode .= "    var marker_{$MAP_No}_{$POI_No} = new GMarker(new GLatLng({$Marker[0]},{$Marker[1]}));\n";
                    if (!empty($MAPinfo)) $kartencode .= "    GEvent.addListener(marker_{$MAP_No}_{$POI_No}, \"click\", function() { marker_{$MAP_No}_{$POI_No}.openInfoWindowHtml(\"{$Marker[2]}\"); });\n";
                    $kartencode .= "    map_{$MAP_No}.addOverlay(marker_{$MAP_No}_{$POI_No});\n";
                    $POI_No++;
                }
                $kartencode .= "  }\n//]]>\n</script>\n";
                $muster = "|\{$kartenpara_komp\}|";
                $acticon = preg_replace($muster, $kartencode, $acticon);
                $MAP_No++;
            }
        } else $acticon = preg_replace("/{((karte),?(.*?))}/i", "{karte=Fehlender APIkey}", $acticon);
    } else $acticon = preg_replace("/{((karte),?(.*?))}/i", "{karte=Fehlende MapCreator.ini}", $acticon);
}

?>
